#ifndef SYSTEMC_H
#include "systemc.h"
#define SYSTEMC_H
#endif

#ifndef COMPTEUR_H
#define COMPTEUR_H

SC_MODULE(compteur)
{
	sc_in<bool> reset;
	sc_in<bool> clk;
	sc_in<bool> up;
	sc_in<bool> load;
	sc_in<sc_uint<4> > val;  
	sc_out<sc_uint<4> > out;  
	
	sc_uint<4> count;
	/* uint pour un compteur de 0 a 15
	   int pour un compteur de -8 a 7 */
	   
	   
	void cpt();
	
	SC_CTOR(compteur)
	{
		SC_METHOD(cpt);
		sensitive_pos << clk << reset;
	}
};
	   
#endif
