#ifndef SYSTEMC_H
#include <systemc.h>
#define SYSTEMC_H
#endif

#ifndef E_S
#include <stdio.h>
#define E_S
#endif

#ifndef DISPLAY_H
#define DISPLAY_H

SC_MODULE(DISPLAY)
{
	sc_in<bool> reset;
	sc_in<bool> clk;
	sc_in<bool> up;
	sc_in<bool> load;
	sc_in<sc_uint<4> > val;  
	sc_in<sc_uint<4> > out;
	
	void sonde()
	{
		int tmp = val.read();
		printf("clk = %d",clk.read());
		printf("  reset = %d",reset.read());
		printf("  up = %d",up.read());
		printf("  load = %d",load.read());
		printf("  val = %d",tmp);
		tmp = out.read();
		printf("  out = %d\n",tmp);
	}
	SC_CTOR(DISPLAY)
	{
		SC_METHOD(sonde);
		sensitive_pos<<clk;
		sensitive<<reset<<up<<load<<val<<out;
	}
};
		
#endif
